
#include "RobboLito.h"

void
mobilita (tipo_posizione *POSIZIONE)
{
  uint64 U, A, T, AA, AT;
  int b;
  DINAMICO->bianco_xray = 0;
  DINAMICO->nero_xray = 0;
  A = attaco_re[POSIZIONE->bianco_re_quadretto];
  DINAMICO->attacco_bianco = A;
  if (A & bitbordo_nero_re)
    DINAMICO->nero_re_scacco = quadretto_fisso[POSIZIONE->bianco_re_quadretto];
  else
    DINAMICO->nero_re_scacco = 0;
  A = attaco_re[POSIZIONE->nero_re_quadretto];
  DINAMICO->attacco_nero = A;
  if (A & bitbordo_bianco_re)
    DINAMICO->bianco_re_scacco = quadretto_fisso[POSIZIONE->nero_re_quadretto];
  else
    DINAMICO->bianco_re_scacco = 0;
  for (U = bitbordo_bianco_cavallo; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_cavallo[b];
      DINAMICO->attacco_bianco |= A;
      if (A & bitbordo_nero_re)
	DINAMICO->nero_re_scacco |= quadretto_fisso[b];
    }
  for (U = bitbordo_bianco_alfiere; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_alfiere (b);
      DINAMICO->attacco_bianco |= A;
      if (A & bitbordo_nero_re)
	DINAMICO->nero_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_nero_re & diagonale[b])
	{
	  T = attaco_alfiere (POSIZIONE->nero_re_quadretto) & A;
	  DINAMICO->bianco_xray |= T;
	  if (T)
	    xray_bianco_lista[BSF (T)] = b;
	}
    }
  for (U = bitbordo_bianco_torre; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_torre (b);
      DINAMICO->attacco_bianco |= A;
      if (A & bitbordo_nero_re)
	DINAMICO->nero_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_nero_re & ortogonale[b])
	{
	  T = attaco_torre (POSIZIONE->nero_re_quadretto) & A;
	  DINAMICO->bianco_xray |= T;
	  if (T)
	    xray_bianco_lista[BSF (T)] = b;
	}
    }
  for (U = bitbordo_bianca_donna; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      AT = attaco_torre (b);
      AA = attaco_alfiere (b);
      A = AA | AT;
      DINAMICO->attacco_bianco |= A;
      if (A & bitbordo_nero_re)
	DINAMICO->nero_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_nero_re & diagonale[b])
	{
	  T = attaco_alfiere (POSIZIONE->nero_re_quadretto) & AA;
	  DINAMICO->bianco_xray |= T;
	  if (T)
	    xray_bianco_lista[BSF (T)] = b;
	}
      else if (bitbordo_nero_re & ortogonale[b])
	{
	  T = attaco_torre (POSIZIONE->nero_re_quadretto) & AT;
	  DINAMICO->bianco_xray |= T;
	  if (T)
	    xray_bianco_lista[BSF (T)] = b;
	}
    }
  for (U = bitbordo_nero_cavallo; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_cavallo[b];
      DINAMICO->attacco_nero |= A;
      if (A & bitbordo_bianco_re)
	DINAMICO->bianco_re_scacco |= quadretto_fisso[b];
    }
  for (U = bitbordo_nero_alfiere; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_alfiere (b);
      DINAMICO->attacco_nero |= A;
      if (A & bitbordo_bianco_re)
	DINAMICO->bianco_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_bianco_re & diagonale[b])
	{
	  T = attaco_alfiere (POSIZIONE->bianco_re_quadretto) & A;
	  DINAMICO->nero_xray |= T;
	  if (T)
	    xray_nero_lista[BSF (T)] = b;
	}
    }
  for (U = bitbordo_nero_torre; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      A = attaco_torre (b);
      DINAMICO->attacco_nero |= A;
      if (A & bitbordo_bianco_re)
	DINAMICO->bianco_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_bianco_re & ortogonale[b])
	{
	  T = attaco_torre (POSIZIONE->bianco_re_quadretto) & A;
	  DINAMICO->nero_xray |= T;
	  if (T)
	    xray_nero_lista[BSF (T)] = b;
	}
    }
  for (U = bitbordo_nera_donna; U; bitLIBERO (b, U))
    {
      b = BSF (U);
      AA = attaco_alfiere (b);
      AT = attaco_torre (b);
      A = AA | AT;
      DINAMICO->attacco_nero |= A;
      if (A & bitbordo_bianco_re)
	DINAMICO->bianco_re_scacco |= quadretto_fisso[b];
      else if (bitbordo_bianco_re & diagonale[b])
	{
	  T = attaco_alfiere (POSIZIONE->bianco_re_quadretto) & AA;
	  DINAMICO->nero_xray |= T;
	  if (T)
	    xray_nero_lista[BSF (T)] = b;
	}
      else if (bitbordo_bianco_re & ortogonale[b])
	{
	  T = attaco_torre (POSIZIONE->bianco_re_quadretto) & AT;
	  DINAMICO->nero_xray |= T;
	  if (T)
	    xray_nero_lista[BSF (T)] = b;
	}
    }
  A = (bitbordo_bianco_pedone & (~COLONNAa)) << 7;
  T = A & bitbordo_nero_re;
  DINAMICO->nero_re_scacco |= (T >> 7);
  DINAMICO->attacco_bianco |= A;
  A = (bitbordo_bianco_pedone & (~COLONNAh)) << 9;
  T = A & bitbordo_nero_re;
  DINAMICO->nero_re_scacco |= (T >> 9);
  DINAMICO->attacco_bianco |= A;
  A = (bitbordo_nero_pedone & (~COLONNAh)) >> 7;
  T = A & bitbordo_bianco_re;
  DINAMICO->bianco_re_scacco |= (T << 7);
  DINAMICO->attacco_nero |= A;
  A = (bitbordo_nero_pedone & (~COLONNAa)) >> 9;
  T = A & bitbordo_bianco_re;
  DINAMICO->bianco_re_scacco |= (T << 9);
  DINAMICO->attacco_nero |= A;
}
